Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::JCRev Class Reference

John Chowning's reverberator class. More...

`#include <JCRev.h>`

Inheritance diagram for stk::JCRev:

## Public Member Functions

| JCRev (StkFloat T60=1.0)
| Class constructor taking a T60 decay time argument (one second default value).
void | clear (void)
| Reset and clear all internal state.
void | setT60 (StkFloat T60)
| Set the reverberation T60 decay time.
StkFloat | lastOut (unsigned int channel=0)
| Return the specified channel value of the last computed stereo frame.
StkFloat | tick (StkFloat input, unsigned int channel=0)
| Input one sample to the effect and return the specified `channel` value of the computed stereo frame.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the effect and replace with stereo outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the effect and write stereo outputs to the `oFrames` object.
Public Member Functions inherited from stk::Effect
| Effect (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual void | setEffectMix (StkFloat mix)
| Set the mixture of input and "effected" levels in the output (0.0 = input only, 1.0 = effect only).
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members

Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

John Chowning's reverberator class.

This class takes a monophonic input signal and produces a stereo output signal. It is derived from the CLM JCRev function, which is based on the use of networks of simple allpass and comb delay filters. This class implements three series allpass units, followed by four parallel comb filters, and two decorrelation delay lines in parallel at the output.

Although not in the original JC reverberator, one-pole lowpass filters have been added inside the feedback comb filters.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Member Function Documentation

## ◆ lastOut()

StkFloat stk::JCRev::lastOut | ( | unsigned int | channel = 0 | ) |

inline

Return the specified channel value of the last computed stereo frame.

Use the lastFrame() function to get both values of the last computed stereo frame. The `channel` argument must be 0 or 1 (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

101{
102#if defined(_STK_DEBUG_)
103 if ( channel > 1 ) {
104 oStream_ << "JCRev::lastOut(): channel argument must be less than 2!";
105 handleError( StkError::FUNCTION_ARGUMENT );
106 }
107#endif
108
109 return lastFrame_[channel];
110}
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tick() [1/3]

StkFloat stk::JCRev::tick | ( | StkFloat | input,
|  | unsigned int | channel = 0 )

inline

Input one sample to the effect and return the specified `channel` value of the computed stereo frame.

Use the lastFrame() function to get both values of the computed stereo output frame. The `channel` argument must be 0 or 1 (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

113{
114#if defined(_STK_DEBUG_)
115 if ( channel > 1 ) {
116 oStream_ << "JCRev::tick(): channel argument must be less than 2!";
117 handleError( StkError::FUNCTION_ARGUMENT );
118 }
119#endif
120
121 StkFloat temp, temp0, temp1, temp2, temp3, temp4, temp5, temp6;
122 StkFloat filtout;
123
124 temp = allpassDelays_[0].lastOut();
125 temp0 = allpassCoefficient_ * temp;
126 temp0 += input;
127 allpassDelays_[0].tick(temp0);
128 temp0 = -(allpassCoefficient_ * temp0) + temp;
129
130 temp = allpassDelays_[1].lastOut();
131 temp1 = allpassCoefficient_ * temp;
132 temp1 += temp0;
133 allpassDelays_[1].tick(temp1);
134 temp1 = -(allpassCoefficient_ * temp1) + temp;
135
136 temp = allpassDelays_[2].lastOut();
137 temp2 = allpassCoefficient_ * temp;
138 temp2 += temp1;
139 allpassDelays_[2].tick(temp2);
140 temp2 = -(allpassCoefficient_ * temp2) + temp;
141
142 temp3 = temp2 + ( combFilters_[0].tick( combCoefficient_[0] * combDelays_[0].lastOut() ) );
143 temp4 = temp2 + ( combFilters_[1].tick( combCoefficient_[1] * combDelays_[1].lastOut() ) );
144 temp5 = temp2 + ( combFilters_[2].tick( combCoefficient_[2] * combDelays_[2].lastOut() ) );
145 temp6 = temp2 + ( combFilters_[3].tick( combCoefficient_[3] * combDelays_[3].lastOut() ) );
146
147 combDelays_[0].tick(temp3);
148 combDelays_[1].tick(temp4);
149 combDelays_[2].tick(temp5);
150 combDelays_[3].tick(temp6);
151
152 filtout = temp3 + temp4 + temp5 + temp6;
153
154 lastFrame_[0] = effectMix_ * (outLeftDelay_.tick(filtout));
155 lastFrame_[1] = effectMix_ * (outRightDelay_.tick(filtout));
156 temp = (1.0 - effectMix_) * input;
157 lastFrame_[0] += temp;
158 lastFrame_[1] += temp;
159
160 return 0.7 * lastFrame_[channel];
161}
stk::JCRev::lastOut
StkFloat lastOut(unsigned int channel=0)
Return the specified channel value of the last computed stereo frame.
Definition JCRev.h:100

## ◆ tick() [2/3]

StkFrames & stk::JCRev::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = 0 )

Take a channel of the StkFrames object as inputs to the effect and replace with stereo outputs.

The StkFrames argument reference is returned. The stereo outputs are written to the StkFrames argument starting at the specified `channel`. Therefore, the `channel` argument must be less than ( channels() - 1 ) of the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

## ◆ tick() [3/3]

StkFrames & stk::JCRev::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = 0,
|  | unsigned int | oChannel = 0 )

Take a channel of the `iFrames` object as inputs to the effect and write stereo outputs to the `oFrames` object.

The `iFrames` object reference is returned. The `iChannel` argument must be less than the number of channels in the `iFrames` argument (the first channel is specified by 0). The `oChannel` argument must be less than ( channels() - 1 ) of the `oFrames` argument. However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

The documentation for this class was generated from the following file:

- JCRev.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.